type token =
  | ID of (string)
  | INTCONSTANT of (string)
  | REALCONSTANT of (string)
  | STRING of (string)
  | CHARACTER of (string)
  | TRUE
  | FALSE
  | NULL
  | THIS
  | NEW
  | SUPER
  | ABSTRACT
  | BOOLEAN
  | BYTE
  | BYVALUE
  | CASE
  | CAST
  | CATCH
  | CHAR
  | CLASS
  | CONST
  | DEFAULT
  | DOUBLE
  | ELSE
  | EXTENDS
  | FINAL
  | FINALLY
  | FLOAT
  | FUTURE
  | GENERIC
  | GHOST
  | GOTO
  | IMPLEMENTS
  | IMPORT
  | INNER
  | INSTANCEOF
  | INT
  | INTEGER
  | INTERFACE
  | LONG
  | MODEL
  | NATIVE
  | OPERATOR
  | OUTER
  | PACKAGE
  | PRIVATE
  | PROTECTED
  | PUBLIC
  | REST
  | REAL
  | SHORT
  | STATIC
  | THROWS
  | TRANSIENT
  | VAR
  | VOID
  | VOLATILE
  | WHILE
  | DO
  | FOR
  | IF
  | SWITCH
  | BREAK
  | CONTINUE
  | RETURN
  | TRY
  | SYNCHRONIZED
  | THROW
  | REQUIRES
  | ENSURES
  | SIGNALS
  | ASSUMES
  | ASSIGNS
  | BEHAVIOR
  | ASSERT
  | INVARIANT
  | LOOP_INVARIANT
  | DECREASES
  | AXIOM
  | LOGIC
  | TYPE
  | PREDICATE
  | READS
  | BSFORALL
  | BSEXISTS
  | BSOLD
  | BSRESULT
  | BSNOTHING
  | NON_NULL
  | NULLABLE
  | LEFTPAR
  | RIGHTPAR
  | LEFTBRACE
  | RIGHTBRACE
  | LEFTBRACKET
  | RIGHTBRACKET
  | SEMICOLON
  | COLON
  | COMMA
  | QUESTIONMARK
  | DOT
  | DOTDOT
  | DOC_COMMENT of (string)
  | ANNOT of (Lexing.position*string)
  | EOF
  | ASSIGNOP of (Java_ast.bin_op)
  | EQ
  | EQEQGT
  | LTEQEQGT
  | VERTICALBARVERTICALBAR
  | AMPERSANDAMPERSAND
  | VERTICALBAR
  | CARET
  | AMPERSAND
  | EQOP of (Java_ast.bin_op)
  | COMP of (Java_ast.bin_op)
  | SHIFT of (Java_ast.bin_op)
  | PLUS
  | MINUS
  | STAR
  | SLASH
  | PERCENT
  | PLUSPLUS
  | MINUSMINUS
  | TILDA
  | BANG

val compilation_unit :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Java_ast.compilation_unit
val kml_type_decl :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Java_ast.type_declaration
val kml_field_decl :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Java_ast.field_declaration
val kml_statement_annot :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Java_ast.pstatement_node
val kml_modifier :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Java_ast.modifier
